﻿unit xeMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Forms, ExtCtrls, XmlIni, Dialogs,
  StdCtrls, Buttons, ComCtrls, Controls;

type
  TfrmXmlIniEditorMain = class(TForm)
    odOpenXmlIni: TOpenDialog;
    sdSaveXmlIni: TSaveDialog;
    odOpenBinaryValue: TOpenDialog;
    sdSaveBinaryValue: TSaveDialog;
    odOpenIni: TOpenDialog;
    sdSaveIni: TSaveDialog;
    Panel1: TPanel;
    btnFile_XmlIni: TBitBtn;
    btnXmlIni_File: TBitBtn;
    btnString_XmlIni: TBitBtn;
    btnXmlIni_String: TBitBtn;
    btnBase64_XmlIni: TBitBtn;
    btnXmlIni_Base64: TBitBtn;
    btnClear: TBitBtn;
    btnRegistry_XmlIni: TBitBtn;
    btnXmlIni_Registry: TBitBtn;
    btnIni_XmlIni: TBitBtn;
    btnXmlIni_Ini: TBitBtn;
    btnShareMem_XmlIni: TBitBtn;
    btnXmlIni_ShareMem: TBitBtn;
    Panel2: TPanel;
    Label1: TLabel;
    lbSections: TListBox;
    btnSaveFileFromSection: TBitBtn;
    btnDelSection: TBitBtn;
    btnLoadFileToSection: TBitBtn;
    btnRenameSection: TBitBtn;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Label2: TLabel;
    lbKeys: TListBox;
    Panel4: TPanel;
    Splitter2: TSplitter;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    cbxCaseSensitive: TCheckBox;
    cbxAutoSave: TCheckBox;
    cbxCompress: TCheckBox;
    btnValueToFile: TBitBtn;
    btnFileToValue: TBitBtn;
    cbEncodeType: TComboBox;
    cbDataType: TComboBox;
    edSection: TRichEdit;
    edKey: TRichEdit;
    edValue: TRichEdit;
    btnFont: TBitBtn;
    fdSetFont: TFontDialog;
    edPassword: TRichEdit;
    Label8: TLabel;
    edPrivateKey: TRichEdit;
    Label9: TLabel;
    edPublicKey: TRichEdit;
    Label10: TLabel;
    btnGenerateKey: TBitBtn;
    Label11: TLabel;
    Label12: TLabel;
    edSignPrivateKey: TRichEdit;
    edVerifySignPublicKey: TRichEdit;
    btnGenerateSignKey: TBitBtn;
    Label13: TLabel;
    chkShowException: TCheckBox;
    cbEncryption: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbSectionsClick(Sender: TObject);
    procedure lbKeysClick(Sender: TObject);
    procedure edKeyChange(Sender: TObject);
    procedure btnXmlIniAccess(Sender: TObject);
    procedure cbxCompressClick(Sender: TObject);
    procedure cbxCaseSensitiveClick(Sender: TObject);
    procedure cbxAutoSaveClick(Sender: TObject);
    procedure chkShowExceptionClick(Sender: TObject);
    procedure btnValueToFileClick(Sender: TObject);
    procedure btnFileToValueClick(Sender: TObject);
    procedure edValueExit(Sender: TObject);
    procedure btnDelSectionClick(Sender: TObject);
    procedure btnLoadFileToSectionClick(Sender: TObject);
    procedure btnSaveFileFromSectionClick(Sender: TObject);
    procedure btnRenameSectionClick(Sender: TObject);
    procedure cbEncodeTypeChange(Sender: TObject);
    procedure cbDataTypeChange(Sender: TObject);
    procedure btnFontClick(Sender: TObject);
    procedure edPasswordChange(Sender: TObject);
    procedure edPrivateKeyChange(Sender: TObject);
    procedure edPublicKeyChange(Sender: TObject);
    procedure edSignPrivateKeyChange(Sender: TObject);
    procedure edVerifySignPublicKeyChange(Sender: TObject);
    procedure btnGenerateKeyClick(Sender: TObject);
    procedure btnGenerateSignKeyClick(Sender: TObject);
    procedure cbEncryptionChange(Sender: TObject);
  private
    FEditXmlIni: TXmlIni;

    procedure ReloadXmlIni;
    procedure ReloadSections;
    procedure ReloadKeys;
    procedure ReloadKey;
  public
  end;

var
  frmXmlIniEditorMain: TfrmXmlIniEditorMain;

implementation

uses
  xeStringIO, xeRegistryIO, XMLTBase;

const
  ApplicationTitle = 'XmlIni Editor';

{$R *.dfm}

procedure TfrmXmlIniEditorMain.ReloadXmlIni;
begin
  if FEditXmlIni.FileName <> '' then
    Application.Title := ApplicationTitle + ' - ' + FEditXmlIni.FileName
  else
    Application.Title := ApplicationTitle + ' - No Name';
  frmXmlIniEditorMain.Caption := Application.Title;
  
  ReloadSections;
end;

procedure TfrmXmlIniEditorMain.ReloadSections;
var
  i: Integer;
  OldSection: string;
begin
  OldSection := '';
  if lbSections.ItemIndex >= 0 then
    OldSection := lbSections.Items[lbSections.ItemIndex];

  FEditXmlIni.Collation;
  lbSections.Items.Clear;
  for i := 0 to FEditXmlIni.Count-1 do
    lbSections.Items.Add(FEditXmlIni.SectionByIndex[i].Name);

  if (OldSection <> '') and (lbSections.Items.IndexOf(OldSection) >= 0) then
    lbSections.ItemIndex := lbSections.Items.IndexOf(OldSection);

  if (edSection.Text <> '') and (lbSections.Items.IndexOf(edSection.Text) >= 0) then
    lbSections.ItemIndex := lbSections.Items.IndexOf(edSection.Text);
    
  ReloadKeys;
end;

procedure TfrmXmlIniEditorMain.ReloadKeys;
var
  i: Integer;
  OldKey: string;
begin
  OldKey := '';
  if lbKeys.ItemIndex >= 0 then
    OldKey := lbKeys.Items[lbKeys.ItemIndex];

  FEditXmlIni[edSection.Text].Collation;
  lbKeys.Items.Clear;
  for i := 0 to FEditXmlIni[edSection.Text].Count-1 do
    lbKeys.Items.Add(FEditXmlIni[edSection.Text].KeyByIndex[i].Name);

  if (OldKey <> '') and (lbKeys.Items.IndexOf(OldKey) >= 0) then
    lbKeys.ItemIndex := lbKeys.Items.IndexOf(OldKey);

  if (edKey.Text <> '') and (lbKeys.Items.IndexOf(edKey.Text) >= 0) then
    lbKeys.ItemIndex := lbKeys.Items.IndexOf(edKey.Text);

  ReloadKey;
end;

procedure TfrmXmlIniEditorMain.ReloadKey;
begin
  if FEditXmlIni.Exists(edSection.Text, edKey.Text) then
  begin
    edValue.Text := FEditXmlIni[edSection.Text][edKey.Text];
    cbDataType.ItemIndex := Integer(FEditXmlIni[edSection.Text].Key[edKey.Text].DataType);
    edValue.Modified := False;
  end
  else
  begin
    edValue.Text := '';
    cbDataType.ItemIndex := 0;
    edValue.Modified := False;
  end;
end;

procedure TfrmXmlIniEditorMain.FormCreate(Sender: TObject);
var
  i: TXmlEncodingType;
begin
  FEditXmlIni := TXmlIni.Create;

  FEditXmlIni.AutoSave := False;
  FEditXmlIni.RaiseException := True;

  cbxCompress.Checked := FEditXmlIni.Compressed;
  cbxAutoSave.Checked := FEditXmlIni.AutoSave;
  cbxCaseSensitive.Checked := FEditXmlIni.CaseSensitive;
  chkShowException.Checked := FEditXmlIni.RaiseException;

  for i := Low(TXmlEncodingType) to High(TXmlEncodingType) do
    cbEncodeType.Items.Add(XT_XML_EncodingStr[i]);
end;

procedure TfrmXmlIniEditorMain.FormDestroy(Sender: TObject);
begin
  FEditXmlIni.Free;
end;

procedure TfrmXmlIniEditorMain.FormShow(Sender: TObject);
begin
  lbSections.Font := edValue.Font;
  lbKeys.Font := edValue.Font;
  edSection.Font := edValue.Font;
  edKey.Font := edValue.Font;

  if (ParamStr(1) <> '') and FileExists(ParamStr(1)) then
  begin
    FEditXmlIni.LoadFromFile(ParamStr(1));
    FEditXmlIni.AutoSave := False;
  end;

  ReloadXmlIni;
  
  cbEncodeType.ItemIndex := Ord(FEditXmlIni.XmlEncoding);
  cbxCompress.Checked := FEditXmlIni.Compressed;
  cbxAutoSave.Checked := FEditXmlIni.AutoSave;
  cbxCaseSensitive.Checked := FEditXmlIni.CaseSensitive;
  cbEncryption.ItemIndex := Ord(FEditXmlIni.EncryptMode);
end;

procedure TfrmXmlIniEditorMain.lbSectionsClick(Sender: TObject);
begin
  edSection.Text := '';
  if lbSections.ItemIndex >= 0 then
    edSection.Text := lbSections.Items[lbSections.ItemIndex];

  ReloadKeys;

  if lbKeys.Items.Count > 0 then
  begin
    lbKeys.ItemIndex := 0;
    lbKeysClick(nil);
  end;
end;

procedure TfrmXmlIniEditorMain.lbKeysClick(Sender: TObject);
begin
  if lbKeys.ItemIndex >= 0 then
    edKey.Text := lbKeys.Items[lbKeys.ItemIndex]
  else
    edKey.Text := '';
end;

procedure TfrmXmlIniEditorMain.edKeyChange(Sender: TObject);
begin
  Application.ProcessMessages;
  ReloadKey;
end;

procedure TfrmXmlIniEditorMain.edValueExit(Sender: TObject);
var
  NewValue: string;
begin
  if edValue.Modified then
  begin
    NewValue := edValue.Text;

    if NewValue = '' then
      FEditXmlIni[edSection.Text].Key[edKey.Text].Clear
    else
    begin
      FEditXmlIni[edSection.Text][edKey.Text] := NewValue;
      cbDataType.ItemIndex := Ord(FEditXmlIni[edSection.Text].Key[edKey.Text].DataType);
    end;

    ReloadSections;
    ReloadKeys;
    
    edValue.Modified := False;
  end;
end;

procedure TfrmXmlIniEditorMain.btnXmlIniAccess(Sender: TObject);
const
  xiAccess_Clear = 0;
  xiAccess_File_XmlIni = 1;
  xiAccess_XmlIni_File = 2;
  xiAccess_String_XmlIni = 3;
  xiAccess_XmlIni_String = 4;
  xiAccess_Base64_XmlIni = 5;
  xiAccess_XmlIni_Base64 = 6;
  xiAccess_Registry_XmlIni = 7;
  xiAccess_XmlIni_Registry = 8;
  xiAccess_INI_XmlIni = 9;
  xiAccess_XmlIni_INI = 10;
  xiAccess_ShareMem_XmlIni = 11;
  xiAccess_XmlIni_ShareMem = 12;
begin
  if not (Sender is TBitBtn) then
    Exit;

  try
    case TBitBtn(Sender).Tag of
      xiAccess_Clear:
        begin
          FEditXmlIni.Clear;
          FEditXmlIni.FileName := '';
          ReloadXmlIni;

          edPassword.Text := '';
          edPrivateKey.Text := '';
          edPublicKey.Text := '';
          edSignPrivateKey.Text := '';
          edVerifySignPublicKey.Text := '';
          edSection.Text := '';
          edKey.Text := '';
        end;
      xiAccess_File_XmlIni:
        begin
          if odOpenXmlIni.Execute then
          begin
            FEditXmlIni.LoadFromFile(odOpenXmlIni.FileName);

            FEditXmlIni.AutoSave := False;

            ReloadXmlIni;
          end;
        end;
      xiAccess_XmlIni_File:
        begin
          if FEditXmlIni.FileName <> '' then
            sdSaveXmlIni.FileName := FEditXmlIni.FileName;
          if sdSaveXmlIni.Execute then
            FEditXmlIni.SaveToFile(sdSaveXmlIni.FileName);

          ReloadXmlIni;
        end;
      xiAccess_String_XmlIni:
        begin
          if frmStringIO.ShowBox(True, FEditXmlIni.SaveToString) then
            FEditXmlIni.LoadFromString(frmStringIO.Value);
          ReloadXmlIni;
        end;
      xiAccess_XmlIni_String:
        begin
          frmStringIO.ShowBox(False, FEditXmlIni.SaveToString);
        end;
      xiAccess_Base64_XmlIni:
        begin
          if frmStringIO.ShowBox(True, FEditXmlIni.SaveToBase64String) then
            FEditXmlIni.LoadFromBase64String(frmStringIO.Value);
          ReloadXmlIni;
        end;
      xiAccess_XmlIni_Base64:
        begin
          frmStringIO.ShowBox(False, FEditXmlIni.SaveToBase64String);
        end;
      xiAccess_Registry_XmlIni:
        begin
          frmRegistryIO.AllowCreateRegKey := False;
          frmRegistryIO.ShowBox;

          FEditXmlIni.LoadFromRegistry(frmRegistryIO.EditKeyPath, frmRegistryIO.EditRootKey);
          ReloadXmlIni;
        end;
      xiAccess_XmlIni_Registry:
        begin
          frmRegistryIO.AllowCreateRegKey := True;
          frmRegistryIO.ShowBox;
        
          FEditXmlIni.SaveToRegistry(frmRegistryIO.EditKeyPath, frmRegistryIO.EditRootKey);
        end;
      xiAccess_INI_XmlIni:
        begin
          if odOpenIni.Execute then
          begin
            FEditXmlIni.LoadFromIni(odOpenIni.FileName);

            FEditXmlIni.AutoSave := False;

            ReloadXmlIni;
          end;
        end;
      xiAccess_XmlIni_INI:
        begin
          if FEditXmlIni.FileName <> '' then
            sdSaveIni.FileName := FEditXmlIni.FileName;
          if sdSaveIni.Execute then
            FEditXmlIni.SaveToIni(sdSaveIni.FileName);

          ReloadXmlIni;
        end;
      xiAccess_ShareMem_XmlIni:
        begin
          FEditXmlIni.LoadFromShareMem(InputBox('ShareMemID', 'Input ShareMemID', ''));

          ReloadXmlIni;
        end;
      xiAccess_XmlIni_ShareMem:
        begin
          FEditXmlIni.SaveToShareMem(InputBox('ShareMemID', 'Input ShareMemID', ''));
        
          ReloadXmlIni;
        end;
    end;

    cbEncodeType.ItemIndex := Ord(FEditXmlIni.XmlEncoding);
    cbxCompress.Checked := FEditXmlIni.Compressed;
    cbxAutoSave.Checked := FEditXmlIni.AutoSave;
    cbxCaseSensitive.Checked := FEditXmlIni.CaseSensitive;
    cbEncryption.ItemIndex := Ord(FEditXmlIni.EncryptMode);
  except
    on E: Exception do
      MessageDlg(E.Message, mtError, [mbOK], 0);
  end;
end;

procedure TfrmXmlIniEditorMain.cbEncodeTypeChange(Sender: TObject);
begin
  FEditXmlIni.XmlEncoding := TXmlEncodingType(cbEncodeType.ItemIndex);
end;

procedure TfrmXmlIniEditorMain.cbEncryptionChange(Sender: TObject);
begin
  FEditXmlIni.EncryptMode := TXmlIniEncryptMode(cbEncryption.ItemIndex);
end;

procedure TfrmXmlIniEditorMain.edPasswordChange(Sender: TObject);
begin
  FEditXmlIni.Password := edPassword.Text;
end;

procedure TfrmXmlIniEditorMain.edPrivateKeyChange(Sender: TObject);
begin
  FEditXmlIni.PrivateKey.Text := edPrivateKey.Text;
end;

procedure TfrmXmlIniEditorMain.edPublicKeyChange(Sender: TObject);
begin
  FEditXmlIni.PublicKey.Text := edPublicKey.Text;
end;

procedure TfrmXmlIniEditorMain.edSignPrivateKeyChange(Sender: TObject);
begin
  FEditXmlIni.SignPrivateKey.Text := edSignPrivateKey.Text;
end;

procedure TfrmXmlIniEditorMain.edVerifySignPublicKeyChange(
  Sender: TObject);
begin
  FEditXmlIni.VerifySignPublicKey.Text := edVerifySignPublicKey.Text;
end;

procedure TfrmXmlIniEditorMain.btnGenerateKeyClick(Sender: TObject);
begin
  FEditXmlIni.GenerateNewEncryptKey;
  edPrivateKey.Text := FEditXmlIni.PrivateKey.Text;
  edPublicKey.Text := FEditXmlIni.PublicKey.Text;
end;

procedure TfrmXmlIniEditorMain.btnGenerateSignKeyClick(Sender: TObject);
begin
  FEditXmlIni.GenerateNewSignKey;
  edSignPrivateKey.Text := FEditXmlIni.SignPrivateKey.Text;
  edVerifySignPublicKey.Text := FEditXmlIni.VerifySignPublicKey.Text;
end;

procedure TfrmXmlIniEditorMain.cbxCompressClick(Sender: TObject);
begin
  FEditXmlIni.Compressed := cbxCompress.Checked;
end;

procedure TfrmXmlIniEditorMain.cbxCaseSensitiveClick(Sender: TObject);
begin
  FEditXmlIni.CaseSensitive := cbxCaseSensitive.Checked;
end;

procedure TfrmXmlIniEditorMain.cbxAutoSaveClick(Sender: TObject);
begin
  FEditXmlIni.AutoSave := cbxAutoSave.Checked;
end;

procedure TfrmXmlIniEditorMain.chkShowExceptionClick(Sender: TObject);
begin
  FEditXmlIni.RaiseException := chkShowException.Checked;
end;

procedure TfrmXmlIniEditorMain.btnValueToFileClick(Sender: TObject);
begin
  if (edSection.Text <> '') and (edKey.Text <> '') then
    if sdSaveBinaryValue.Execute then
      FEditXmlIni[edSection.Text].Key[edKey.Text].ValueSaveToFile(sdSaveBinaryValue.FileName);
end;

procedure TfrmXmlIniEditorMain.btnFileToValueClick(Sender: TObject);
begin
  if (edSection.Text <> '') and (edKey.Text <> '') then
    if odOpenBinaryValue.Execute then
    begin
      FEditXmlIni[edSection.Text].Key[edKey.Text].ValueLoadFromFile(odOpenBinaryValue.FileName);
      edValue.Text := FEditXmlIni[edSection.Text].Key[edKey.Text].Text;
      edValueExit(nil);
    end;
end;

procedure TfrmXmlIniEditorMain.btnRenameSectionClick(Sender: TObject);
var
  NewName, OldName: string;
begin
  if lbSections.ItemIndex >= 0 then
  begin
    OldName := lbSections.Items[lbSections.ItemIndex];
    NewName := InputBox('Section更改名稱', '新的Section Name', OldName);
    FEditXmlIni.Section[OldName].Name := NewName;
    ReloadSections;
  end;
end;

procedure TfrmXmlIniEditorMain.btnLoadFileToSectionClick(Sender: TObject);
var
  SectionName: string;
begin
  if odOpenXmlIni.Execute then
  begin
    if lbSections.ItemIndex >= 0 then
      SectionName := lbSections.Items[lbSections.ItemIndex]
    else
      SectionName := '';

    SectionName := InputBox('Section 名稱', '請輸入Section名稱:', SectionName);

    FEditXmlIni.Section[SectionName].LoadFromFile(odOpenXmlIni.FileName, SectionName);

    ReloadSections;
  end;
end;

procedure TfrmXmlIniEditorMain.btnSaveFileFromSectionClick(
  Sender: TObject);
var
  SectionName: string;
begin
  if lbSections.ItemIndex < 0 then
    Exit;

  SectionName := lbSections.Items[lbSections.ItemIndex];

  SectionName := InputBox('Section 名稱', '請輸入Section名稱:', SectionName);

  if sdSaveXmlIni.Execute then
    FEditXmlIni.Section[lbSections.Items[lbSections.ItemIndex]].SaveToFile(sdSaveXmlIni.FileName, SectionName);
end;

procedure TfrmXmlIniEditorMain.btnDelSectionClick(Sender: TObject);
begin
  if lbSections.ItemIndex >= 0 then
    FEditXmlIni.Delete(lbSections.Items[lbSections.ItemIndex]);
  ReloadSections;
  edSection.Text := '';
  edKey.Text := '';
end;

procedure TfrmXmlIniEditorMain.cbDataTypeChange(Sender: TObject);
begin
  FEditXmlIni[edSection.Text].Key[edKey.Text].DataType := TXmlIniDataType(cbDataType.ItemIndex);
  ReloadKey;
end;

procedure TfrmXmlIniEditorMain.btnFontClick(Sender: TObject);
begin
  fdSetFont.Font.Assign(Font);
  if fdSetFont.Execute then
  begin
    Font.Assign(fdSetFont.Font);

    lbSections.Hide;
    lbSections.Font.Assign(Font);
    lbSections.Show;

    lbKeys.Hide;
    lbKeys.Font.Assign(Font);
    lbKeys.Show;

    edSection.Hide;
    edSection.Font.Assign(Font);
    edSection.Show;

    edKey.Hide;
    edKey.Font.Assign(Font);
    edKey.Show;

    edValue.Hide;
    edValue.Font.Assign(Font);
    edValue.Show;
  end;
end;

end.
